package com.rjconsultores.ventaboletos.web.gui.controladores.relatorios;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.sql.DataSource;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Bandbox;
import org.zkoss.zul.Comboitem;
import org.zkoss.zul.Datebox;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Radio;
import org.zkoss.zul.Textbox;

import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.Estacion;
import com.rjconsultores.ventaboletos.entidad.PuntoVenta;
import com.rjconsultores.ventaboletos.entidad.TipoPuntoVenta;
import com.rjconsultores.ventaboletos.entidad.Usuario;
import com.rjconsultores.ventaboletos.relatorios.impl.RelatorioVendasCartoes;
import com.rjconsultores.ventaboletos.relatorios.impl.RelatorioVendasCartoesAlternativo;
import com.rjconsultores.ventaboletos.relatorios.utilitarios.Relatorio;
import com.rjconsultores.ventaboletos.service.TipoPuntoVentaService;
import com.rjconsultores.ventaboletos.utilerias.DateUtil;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyComboboxEstacion;
import com.rjconsultores.ventaboletos.web.utilerias.MyComboboxEstandar;
import com.rjconsultores.ventaboletos.web.utilerias.MyComboboxPuntoVenta;
import com.rjconsultores.ventaboletos.web.utilerias.MyComboboxUsuario;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderTipoPuntoVenta;
import com.trg.search.Filter;

@Controller("relatorioVendasCartoesController")
@Scope("prototype")
public class RelatorioVendasCartoesController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;

	private Datebox dataInicial;
	private Datebox dataFinal;
	private MyComboboxEstandar cmbEmpresa;
	private MyComboboxPuntoVenta cmbPuntoVenta;
	private MyComboboxEstacion cmbEstacion;
	private MyComboboxUsuario cmbUsuario;
	private List<Empresa> lsEmpresa;
	@Autowired
	private TipoPuntoVentaService tipoPuntoVentaService;
	private List<TipoPuntoVenta> lsTipoPuntoVenta;
	private MyListbox tipoPuntoVentaList;
	private MyListbox tipoPuntoVentaSelList;
	private Paging pagingtipoPuntoVenta;
	private Textbox txtPalavraPesquisa;
	@Autowired
	private transient PagedListWrapper<TipoPuntoVenta> plwtipoPuntoVenta;
	private static final String TODOS_VALUE = new Integer(-1).toString();
	private static final String TODOS = "TODAS";
	private Bandbox bbPesquisaPuntoVenta;

	private Radio radioDataVenda;

	@Autowired
	private DataSource dataSourceRead;

	@Override
	public void doAfterCompose(Component comp) throws Exception {

		super.doAfterCompose(comp);
		lsEmpresa = UsuarioLogado.getUsuarioLogado().getEmpresa();
		lsTipoPuntoVenta = tipoPuntoVentaService.obtenerTodos();
		tipoPuntoVentaSelList.setItemRenderer(new RenderTipoPuntoVenta());
	}

	/**
	 * @throws Exception
	 * 
	 */
	@SuppressWarnings({ "rawtypes", "unchecked" })
	private void executarRelatorio(boolean isLayoutAlternatico) throws Exception {
		Map<String, Object> parametros = new HashMap<String, Object>();

		if (dataInicial.getValue() == null) {
			return;
		}
		if (dataFinal.getValue() == null) {
			return;
		}
		parametros.put("NOME_RELATORIO", Labels.getLabel("relatorioVendasCartoesController.window.title"));

		lsTipoPuntoVenta = new ArrayList(Arrays.asList(tipoPuntoVentaSelList.getData()));

		if (lsTipoPuntoVenta.size() > 0) {
			String puntoVentaExpression = null;
			for (TipoPuntoVenta p : lsTipoPuntoVenta) {
				if (lsTipoPuntoVenta.indexOf(p) == 0) {
					puntoVentaExpression = p.getTipoptovtaId().toString();
				} else {
					puntoVentaExpression += ", " + p.getTipoptovtaId().toString();
				}
			}
			parametros.put("TIPOPUNTOVENTA_ID", puntoVentaExpression);
			parametros.put("TIPOPUNTOVENTA", puntoVentaExpression);
		} else {
			parametros.put("TIPOPUNTOVENTA_ID", TODOS_VALUE);
			parametros.put("TIPOPUNTOVENTA", TODOS);
		}

		StringBuilder filtro = new StringBuilder("Filtros\n");

		Comboitem itemEmpresa = cmbEmpresa.getSelectedItem();
		if (itemEmpresa != null) {
			Empresa empresa = (Empresa) itemEmpresa.getValue();
			if (empresa.getEmpresaId() > -1) {
				parametros.put("EMPRESA", empresa);
				parametros.put("NOME_EMPRESA", empresa.getNombempresa());
				filtro.append(empresa.getNombempresa());
			} else {
				filtro.append("Todas");
			}
		} else {
			filtro.append("Todas");
		}

		Comboitem itemPuntoVenta = cmbPuntoVenta.getSelectedItem();
		if (itemPuntoVenta != null) {
			PuntoVenta puntoVenta = (PuntoVenta) itemPuntoVenta.getValue();
			if (puntoVenta.getPuntoventaId() > -1) {
				parametros.put("PUNTOVENTA", puntoVenta);
				parametros.put("NOME_AGENCIA", puntoVenta.getNombpuntoventa());
			} else {
				parametros.put("NOME_AGENCIA", "Todas");
			}
		} else {
			parametros.put("NOME_AGENCIA", "Todas");
		}

		Comboitem cbiUsuario = cmbUsuario.getSelectedItem();
		if (cbiUsuario != null) {
			Usuario usuario = (Usuario) cbiUsuario.getValue();
			if (usuario.getUsuarioId() > -1) {
				parametros.put("USUARIO", usuario);
				parametros.put("NOME_USUARIO", usuario.getNombUsuarioCompleto());
			} else {
				parametros.put("NOME_USUARIO", "Todos");
			}
		} else {
			parametros.put("NOME_USUARIO", "Todos");
		}

		Comboitem itemEstacion = cmbEstacion.getSelectedItem();
		if (itemEstacion != null) {
			Estacion estacion = (Estacion) itemEstacion.getValue();
			if (estacion.getEstacionId() > -1) {
				parametros.put("ESTACION", estacion);
				parametros.put("ESTACAO", estacion.getDescestacion());
			} else {
				parametros.put("ESTACAO", "Todas");
			}
		} else {
			parametros.put("ESTACAO", "Todas");
		}

		parametros.put("DATA_INICIAL", DateUtil.getStringDate(dataInicial.getValue(), "dd/MM/yyyy"));
		parametros.put("DATA_FINAL", DateUtil.getStringDate(dataFinal.getValue(), "dd/MM/yyyy"));

		parametros.put("FILTROS", filtro.toString());
		Relatorio relatorio = null;
		if (isLayoutAlternatico) {
			relatorio = new RelatorioVendasCartoesAlternativo(parametros, dataSourceRead.getConnection(), radioDataVenda.isSelected());
		} else {
			relatorio = new RelatorioVendasCartoes(parametros, dataSourceRead.getConnection(), radioDataVenda.isSelected());
		}

		Map args = new HashMap();
		args.put("relatorio", relatorio);

		openWindow("/component/reportView.zul",
				Labels.getLabel("relatorioVendasCartoesController.window.title"), args, MODAL);
	}

	public void onClick$btnPesquisa(Event ev) {
		executarPesquisa();
	}

	private void executarPesquisa() {

		HibernateSearchObject<TipoPuntoVenta> tipoPuntoVentaBusqueda = new HibernateSearchObject<TipoPuntoVenta>(TipoPuntoVenta.class,
				pagingtipoPuntoVenta.getPageSize());

		tipoPuntoVentaBusqueda.addFilterOr(Filter.like("desctipo", "%" + txtPalavraPesquisa.getText().trim().toUpperCase().concat("%")), Filter.like("desctipo", "%" + txtPalavraPesquisa.getText().trim().toUpperCase().concat("%")));

		tipoPuntoVentaBusqueda.addSortAsc("desctipo");

		tipoPuntoVentaBusqueda.addFilterEqual("activo", Boolean.TRUE);

		plwtipoPuntoVenta.init(tipoPuntoVentaBusqueda, tipoPuntoVentaList, pagingtipoPuntoVenta);

		if (tipoPuntoVentaList.getData().length == 0) {
			try {
				Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
						Labels.getLabel("relatorioReceitaDiariaAgenciaController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);
			} catch (InterruptedException ex) {
			}
		}
	}

	public void onClick$btnExecutarRelatorio(Event ev) throws Exception {
		executarRelatorio(false);
	}

	public void onClick$btnExecutarRelatorioAlternativo(Event ev) throws Exception {
		executarRelatorio(true);
	}

	public void onDoubleClick$tipoPuntoVentaList(Event ev) {
		TipoPuntoVenta puntoVentaSel = (TipoPuntoVenta) tipoPuntoVentaList.getSelected();
		tipoPuntoVentaSelList.addItemNovo(puntoVentaSel);
	}

	public void onDoubleClick$tipoPuntoVentaSelList(Event ev) {
		TipoPuntoVenta puntoVentaSel = (TipoPuntoVenta) tipoPuntoVentaSelList.getSelected();
		tipoPuntoVentaSelList.removeItem(puntoVentaSel);
	}

	private void limparPesquisaTipoAgencia() {
		tipoPuntoVentaList.clearSelection();
		lsTipoPuntoVenta.clear();
		this.bbPesquisaPuntoVenta.setValue("");
	}

	public Datebox getDatInicial() {
		return dataInicial;
	}

	public void onClick$btnLimpar(Event ev) {
		limparPesquisaTipoAgencia();
	}

	public void setDatInicial(Datebox datInicial) {
		this.dataInicial = datInicial;
	}

	public Datebox getDatFinal() {
		return dataFinal;
	}

	public void setDatFinal(Datebox datFinal) {
		this.dataFinal = datFinal;
	}

	public List<Empresa> getLsEmpresa() {
		return lsEmpresa;
	}

	public void setLsEmpresa(List<Empresa> lsEmpresa) {
		this.lsEmpresa = lsEmpresa;
	}

	public MyComboboxEstandar getCmbEmpresa() {
		return cmbEmpresa;
	}

	public void setCmbEmpresa(MyComboboxEstandar cmbEmpresa) {
		this.cmbEmpresa = cmbEmpresa;
	}

	public Radio getRadioDataVenda() {
		return radioDataVenda;
	}

	public void setRadioDataVenda(Radio radioDataVenda) {
		this.radioDataVenda = radioDataVenda;
	}
}
